# Terms & Conditions
These Terms & Conditions create a contract between You and Česká spořitelna, a.s., having its registered seat at Praha 4, Olbrachtova 1929/62, PSČ 140 00, Česká republika, IN: 45244782, registered in the Commercial Register kept by the Municipal Court in Prague, Section B, File No. 1171 (hereinafter referred to as “the Bank”). Please, read these Terms & Conditions carefully. 

These Terms & Conditions govern Your use of the SDK as defined below. 

### DEFINITIONS
* “**SDK**” means a set of software tools including its source code, which enable developers an easy integration to the Bank´s API, that is licenced under this Terms & Conditions.

* “**Guidelines**“ means a set of rules of how to modify the SDK in order not to infringe the provisions of these Terms & Conditions. These are the part of the Repository.

* “**Repository**” means a storage location from which You may retrieve the SDK and the Guidelines.

### LICENSE GRANT
You must accept this Terms & Conditions before you start using the SDK. By downloading the SDK or other using any portion of the SDK, You agree to these Terms & Conditions. If you do not accept these Terms & Conditions, you are not authorised to use the SDK under any relevant copyright law.

Subject to the terms and conditions of these Terms & Conditions, the Bank grants You a non-exclusive, worldwide, revocable, time unlimited (until revocation), free of charge, non-assignable and non-transferable license to use the SDK and other content of the Repository. 

**Your rights and obligations thereof are as follows:**

1. You can enter and download and use the content of the Repository; 
2. You can use the downloaded SDK for purpose of its implementation within your own software product in order to enable Your products to access the Bank’s API easily; 
3. You can modify the SDK only in compliance with the Guidelines. That means You can propose a draft of change or adjustment of the SDK in order to improve the function of it towards the Bank and after the evaluation of impacts, scope and performance of such conduct and obtaining of the Bank’s approval You can use the approved modified version of the SDK;
4. While performing Your rights You are not allowed to omit the author or change the license type; 
5. You are not permitted to use the SDK in other way than described in these Terms & Conditions, especially to copy the SDK in order to use it as a part of your own software for other purpose than to access the Bank’s API, to distribute the SDK or to make a sublicense to it for both commercial and non-commercial use; 
6. You provide the Bank with a worldwide, irrevocable, time unlimited, free of charge, exclusive, assignable and transferable license and a right to make a sublicense for using Your modifications to the SDK.

### OWNERSHIP 
Title to the SDK remains with the Bank. The SDK is copyrighted and is protected by the Czech Republic and European Union copyright laws and international treaty provisions. You agree to prevent unauthorized copying of the SDK. Except as expressly provided herein, the Bank does not grant any express or implied right to You under the Bank patents, copyrights, trademarks, or trade secret information.

### UPGRADES, UPDATES, NEW VERSIONS
The Bank may make changes to the SDK or a new version of it from time to time and shall notice You about the possibility to obtain the changed SDK or new version thereof. In case there is a new version released, the Bank has the right to delete the previous version of SDK or to deny access to the previous version of SDK.

### DISCLAIMER OF WARRANTY
The SDK is licensed "as-is." You bear the risk of using it and in no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing,  the Bank gives no expressed or implied warranties, guarantees or conditions with regard to the SDK, including all warranties of merchantability, fitness for a particular purpose, title and non-infringement.

### LIMITATION OF LIABILITY
In the maximum extent permitted by law, the Bank is not liable for any damages, including any direct or indirect damages of any character arising as a result of this License or out of the use or inability to use the SDK (including but not limited to damages for loss of profit, computer failure or malfunction, or any and all other commercial damages or losses), even if the Bank has been advised of the possibility of such damages.

### GOVERNING LAW
These Terms & Conditions will in all respects be governed by, and construed and interpreted under, the laws of the Czech Republic, without reference to conflict of laws principles. All disputes arising out of or related to these Terms & Conditions, whether based on contract, tort, or any other legal or equitable theory, will be subject to the exclusive jurisdiction of the courts of the Czech Republic. Each party submits to the personal jurisdiction of those courts and waives all objections to that jurisdiction.

### SEVERABILITY
Should any term of these Terms & Conditions be declared void or unenforceable by any court of competent jurisdiction, such declaration shall have no effect on the remaining terms hereof. 

### NO WAIVER 
The failure of either party to enforce any rights granted under these Terms & Conditions or to take action against the other party in the event of any breach hereunder shall not be deemed a waiver by that party as to subsequent enforcement of rights or subsequent actions in the event of future breaches. 

### UNDERSTANDING, AUTHORITY AND BINDING EFFECT
By starting to use the SDK You agree and acknowledge that You have fully read, understood, accepted and agree to each and every provision, term and condition contained in these Terms & Conditions. 

### HEADINGS
The headings and titles to the sections of these Terms & Conditions are inserted for convenience only and shall not be deemed a part of, or affect the construction or interpretation of, the provisions of these Terms & Conditions.
