/**
 * @export
 * @class Signer
 */
export declare class Signer {
    private _apiKey;
    private _privateKey;
    /**
     * Creates an instance of Signer.
     * @param {string} apiKey
     * @param {string} privateKey
     *
     * @memberOf Signer
     */
    constructor(apiKey: string, privateKey: string);
    /**
     * @returns {string}
     *
     * @memberOf Signer
     */
    generateNonce(): string;
    /**
     * @param {string} url
     * @param {string} data
     * @param {string} nonce
     * @returns {string}
     *
     * @memberOf Signer
     */
    generateSignatureForRequest(url: string, data: string, nonce: string): string;
    /**
     * @param {string} url
     * @param {string} data
     * @param {object} headers
     *
     * @memberOf Signer
     */
    signRequest(url: string, data: string, headers: any): void;
    /**
     * @param {any} url
     * @returns {string}
     *
     * @memberOf Signer
     */
    stripServer(url: any): string;
}
