import { Environment } from '../core/environment';
/**
 * @export
 * @class JudgeSession
 */
export declare class JudgeSession {
    sessionId: string;
    private baseUrl;
    /**
     * Creates an instance of JudgeSession.
     * @param {string} sessionId
     * @param {string} [baseUrl]
     *
     * @memberOf JudgeSession
     */
    constructor(sessionId: string, baseUrl?: string);
    /**
     * @param {string} nextCase
     * @returns {Promise<any>}
     *
     * @memberOf JudgeSession
     */
    setNextCase(nextCase: string): Promise<any>;
}
/**
 * @export
 * @class Judge
 */
export declare class Judge {
    static JudgeSessionHeaderName: string;
    static JudgeCaseHeaderName: string;
    static DefaultBaseURL: string;
    static DefaultTestEnvironment: Environment;
    private baseUrl;
    /**
     * Creates an instance of Judge.
     * @param {string=} baseUrl
     *
     * @memberOf Judge
     */
    constructor(baseUrl?: string);
    /**
     * @readonly
     * @returns {Environment}
     *
     * @memberOf Judge
     */
    readonly testEnvironment: Environment;
    /**
     * @private
     * @static
     * @type {string}
     * @memberOf Judge
     */
    private static CurrentSessionId;
    /**
     * @returns {JudgeSession}
     *
     * @memberOf Judge
     */
    startNewSession(): JudgeSession;
}
