// <reference path="../../../typings/es6-promise/es6-promise.d.ts" />
// <reference path="../../../typings/jasmine/jasmine.d.ts" />
import {
    ResourceUtils,
    Resource,
    InstanceResource,
    HasInstanceResource,
    GetEnabled,
    UpdateEnabled,
    CreateEnabled,
    DeleteEnabled,
    ListEnabled,
    Paginated,
    ListResponse,
    EmptyResponse,
    Signable,
    SigningUtils } from '../../../lib/core-sdk';
    
    export class ContactsResource extends Resource {
        get personal (): PersonalResource {
            return new PersonalResource(this.getPath() + '/personal', this.getClient()) 
        } 
    }
    
    export class PersonalResource extends Resource 
    implements CreateEnabled<CreatePersonalContactRequest, CreatePersonalContactResponse> {
        
        create = (payload: CreatePersonalContactRequest): Promise<CreatePersonalContactResponse> => {
            return ResourceUtils.CallCreate(this, payload).then((response: CreatePersonalContactResponse) => {
                SigningUtils.createSigningObject(response, this.getClient(), `${this.getClient().getPath()}/contacts/${(<CreatePersonalContactResponse>response).id}`);
                return response;
            })
        }
    }
    
    export interface CreatePersonalContactRequest {
        name: string;
        phoneNumber: string;
    }
    
    export interface CreatePersonalContactResponse extends CreatePersonalContactRequest, Signable {
        id: number;
    }